Index: pjproject/trunk/pjsip-apps/src/pjsua/ios/ipjsua.xcodeproj/project.pbxproj
===================================================================
--- pjproject/trunk/pjsip-apps/src/pjsua/ios/ipjsua.xcodeproj/project.pbxproj	(revision 5009)
+++ pjproject/trunk/pjsip-apps/src/pjsua/ios/ipjsua.xcodeproj/project.pbxproj	(revision 5010)
@@ -290,4 +290,9 @@
 				LastUpgradeCheck = 0450;
 				ORGANIZATIONNAME = Teluu;
+				TargetAttributes = {
+					3AF0580316F050770046B835 = {
+						DevelopmentTeam = 93NHJQ455P;
+					};
+				};
 			};
 			buildConfigurationList = 3AF057FE16F050770046B835 /* Build configuration list for PBXProject "ipjsua" */;
@@ -425,4 +430,5 @@
 			isa = XCBuildConfiguration;
 			buildSettings = {
+				CODE_SIGN_IDENTITY = "iPhone Developer";
 				GCC_PRECOMPILE_PREFIX_HEADER = YES;
 				GCC_PREFIX_HEADER = "ipjsua/ipjsua-Prefix.pch";
@@ -464,4 +470,5 @@
 			isa = XCBuildConfiguration;
 			buildSettings = {
+				CODE_SIGN_IDENTITY = "iPhone Developer";
 				GCC_PRECOMPILE_PREFIX_HEADER = YES;
 				GCC_PREFIX_HEADER = "ipjsua/ipjsua-Prefix.pch";
Index: pjproject/trunk/pjsip-apps/src/pjsua/ios/ipjsua.xcodeproj/xcshareddata/xcschemes/ipjsua.xcscheme
===================================================================
--- pjproject/trunk/pjsip-apps/src/pjsua/ios/ipjsua.xcodeproj/xcshareddata/xcschemes/ipjsua.xcscheme	(revision 5010)
+++ pjproject/trunk/pjsip-apps/src/pjsua/ios/ipjsua.xcodeproj/xcshareddata/xcschemes/ipjsua.xcscheme	(revision 5010)
@@ -0,0 +1,88 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<Scheme
+   LastUpgradeVersion = "0620"
+   version = "1.3">
+   <BuildAction
+      parallelizeBuildables = "YES"
+      buildImplicitDependencies = "YES">
+      <BuildActionEntries>
+         <BuildActionEntry
+            buildForTesting = "YES"
+            buildForRunning = "YES"
+            buildForProfiling = "YES"
+            buildForArchiving = "YES"
+            buildForAnalyzing = "YES">
+            <BuildableReference
+               BuildableIdentifier = "primary"
+               BlueprintIdentifier = "3AF0580316F050770046B835"
+               BuildableName = "ipjsua.app"
+               BlueprintName = "ipjsua"
+               ReferencedContainer = "container:ipjsua.xcodeproj">
+            </BuildableReference>
+         </BuildActionEntry>
+      </BuildActionEntries>
+   </BuildAction>
+   <TestAction
+      selectedDebuggerIdentifier = "Xcode.DebuggerFoundation.Debugger.LLDB"
+      selectedLauncherIdentifier = "Xcode.DebuggerFoundation.Launcher.LLDB"
+      shouldUseLaunchSchemeArgsEnv = "YES"
+      buildConfiguration = "Debug">
+      <Testables>
+      </Testables>
+      <MacroExpansion>
+         <BuildableReference
+            BuildableIdentifier = "primary"
+            BlueprintIdentifier = "3AF0580316F050770046B835"
+            BuildableName = "ipjsua.app"
+            BlueprintName = "ipjsua"
+            ReferencedContainer = "container:ipjsua.xcodeproj">
+         </BuildableReference>
+      </MacroExpansion>
+   </TestAction>
+   <LaunchAction
+      selectedDebuggerIdentifier = "Xcode.DebuggerFoundation.Debugger.LLDB"
+      selectedLauncherIdentifier = "Xcode.DebuggerFoundation.Launcher.LLDB"
+      launchStyle = "0"
+      useCustomWorkingDirectory = "NO"
+      buildConfiguration = "Debug"
+      ignoresPersistentStateOnLaunch = "NO"
+      debugDocumentVersioning = "YES"
+      allowLocationSimulation = "YES">
+      <BuildableProductRunnable
+         runnableDebuggingMode = "0">
+         <BuildableReference
+            BuildableIdentifier = "primary"
+            BlueprintIdentifier = "3AF0580316F050770046B835"
+            BuildableName = "ipjsua.app"
+            BlueprintName = "ipjsua"
+            ReferencedContainer = "container:ipjsua.xcodeproj">
+         </BuildableReference>
+      </BuildableProductRunnable>
+      <AdditionalOptions>
+      </AdditionalOptions>
+   </LaunchAction>
+   <ProfileAction
+      shouldUseLaunchSchemeArgsEnv = "YES"
+      savedToolIdentifier = ""
+      useCustomWorkingDirectory = "NO"
+      buildConfiguration = "Release"
+      debugDocumentVersioning = "YES">
+      <BuildableProductRunnable
+         runnableDebuggingMode = "0">
+         <BuildableReference
+            BuildableIdentifier = "primary"
+            BlueprintIdentifier = "3AF0580316F050770046B835"
+            BuildableName = "ipjsua.app"
+            BlueprintName = "ipjsua"
+            ReferencedContainer = "container:ipjsua.xcodeproj">
+         </BuildableReference>
+      </BuildableProductRunnable>
+   </ProfileAction>
+   <AnalyzeAction
+      buildConfiguration = "Debug">
+   </AnalyzeAction>
+   <ArchiveAction
+      buildConfiguration = "Release"
+      revealArchiveInOrganizer = "YES">
+   </ArchiveAction>
+</Scheme>
Index: pjproject/trunk/pjsip-apps/src/pjsua/ios/ipjsua.xcworkspace/xcshareddata/ipjsua.xccheckout
===================================================================
--- pjproject/trunk/pjsip-apps/src/pjsua/ios/ipjsua.xcworkspace/xcshareddata/ipjsua.xccheckout	(revision 5009)
+++ pjproject/trunk/pjsip-apps/src/pjsua/ios/ipjsua.xcworkspace/xcshareddata/ipjsua.xccheckout	(revision 5010)
@@ -15,9 +15,9 @@
 	</dict>
 	<key>IDESourceControlProjectPath</key>
-	<string>pjsip-apps/src/pjsua/ios/ipjsua.xcodeproj</string>
+	<string>pjsip-apps/src/pjsua/ios/ipjsua.xcworkspace</string>
 	<key>IDESourceControlProjectRelativeInstallPathDictionary</key>
 	<dict>
 		<key>74dad513-b988-da41-8d7b-12977e46ad98++2595</key>
-		<string>../../../../../..</string>
+		<string>../../../../..</string>
 	</dict>
 	<key>IDESourceControlProjectRepositoryRootDictionary</key>
@@ -27,5 +27,5 @@
 	</dict>
 	<key>IDESourceControlProjectURL</key>
-	<string>https://svn.pjsip.org/repos/pjproject/trunk/pjsip-apps/src/pjsua/ios/ipjsua.xcodeproj</string>
+	<string>https://svn.pjsip.org/repos/pjproject/trunk/pjsip-apps/src/pjsua/ios/ipjsua.xcworkspace</string>
 	<key>IDESourceControlProjectVersion</key>
 	<integer>111</integer>